#include <amxmodx> 
#include <amxmisc>

new const PLUGIN[]  = "Ping alto = kickado"
new const VERSION[] = "1.0"
new const AUTHOR[]  = "EFFx"

#define HPK_IMMUNE ADMIN_IMMUNITY

new hpk_ping, hpk_check, hpk_tests, hpk_delay, hpk_immunity,hpk_kick
new gSayText

new g_Ping[33]
new g_Samples[33]

public plugin_init() 
{

	register_plugin(PLUGIN, VERSION, AUTHOR)

	gSayText = get_user_msgid("SayText")
	
	register_concmd("amx_hpk","cmdHpk",ADMIN_CVAR,"- configures high ping kicker")

	hpk_ping = register_cvar("amx_hpk_max","250")
	hpk_check = register_cvar("amx_hpk_check","12")
	hpk_tests = register_cvar("amx_hpk_tests","5")
	hpk_delay = register_cvar("amx_hpk_delay","30")
	hpk_immunity = register_cvar("amx_hpk_immunity","1")
	hpk_kick = register_cvar("amx_hpk_kick","1")
	
	register_dictionary("furien_gamesites.txt")

	if (get_pcvar_num(hpk_check) < 5) set_pcvar_num(hpk_check,5)
	if (get_pcvar_num(hpk_tests) < 3) set_pcvar_num(hpk_tests,3)
}

public client_disconnect(id) 
	remove_task(id)

public client_putinserver(id) 
{    
	g_Ping[id] = 0 
	g_Samples[id] = 0

	if ( !is_user_bot(id) ) 
	{
		new param[1]
		param[0] = id 
    
		if (get_pcvar_num(hpk_delay) != 0) 
		{
			set_task( float(get_pcvar_num(hpk_delay)), "taskSetting", id, param , 1)
		}
		else 
		{	    
			set_task( float(get_pcvar_num(hpk_check)) , "checkPing" , id , param , 1 , "b" )
		}
	}
}


public taskSetting(param[]) {
	new name[32]
	get_user_name(param[0],name,31)
	set_task( float(get_pcvar_num(hpk_check)) , "checkPing" , param[0] , param , 1 , "b" )
}

kickPlayer(id) 
{ 
	if(!get_pcvar_num(hpk_kick))
	return
	
	new name[32],authid[36]
	get_user_name(id,name,31)
	get_user_authid(id,authid,35)
	
	ChatColor(0,"!y[Anti-Cheat] %L",LANG_PLAYER, "HPK_PLAYER_KICKED", name)
	server_cmd("kick #%d ^"%L^"",get_user_userid(id), id, "HPK_PLAYER_KICKED_REASON")
	log_amx("HPK: ^"%s<%d><%s>^"%L (%d)", name,get_user_userid(id),authid, id, "HPK_PLAYER_KICKED_LOG", (g_Ping[id] / g_Samples[id]))
}

public checkPing(param[]) 
{ 

	if (get_pcvar_num(hpk_tests) < 3)
		set_pcvar_num(hpk_tests,3)

	new id = param[ 0 ] 

	if ( get_user_flags(id) & HPK_IMMUNE && get_pcvar_num(hpk_immunity) == 1 ) 
	{
		remove_task(id)
		return PLUGIN_CONTINUE
	}

	new ping, loss

	get_user_ping(id,ping,loss) 

	g_Ping[ id ] += ping
	++g_Samples[ id ]

	if ( (g_Samples[ id ] > get_pcvar_num(hpk_tests)) && (g_Ping[id] / g_Samples[id] > get_pcvar_num(hpk_ping))  )    
		kickPlayer(id)

	return PLUGIN_CONTINUE
}

  
public cmdHpk(id,level,cid) 
{
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	if (read_argc() < 6) 
	{
		return PLUGIN_HANDLED
	}

	new name[32], authid[36]
	get_user_name(id,name,31)
	get_user_authid(id,authid,35)

	new ping_arg[5], check_arg[5], tests_arg[5], delay_arg[5], immune_arg[5]
	read_argv(1,ping_arg,4)
	read_argv(2,tests_arg,4)
	read_argv(3,check_arg,4)
	read_argv(4,delay_arg,4)
	read_argv(5,immune_arg,4)
  
	new ping = str_to_num(ping_arg)
	new tests = str_to_num(tests_arg)
	new check = str_to_num(check_arg)
	new delay = str_to_num(delay_arg)
	new immune = str_to_num(immune_arg)

	if ( check < 5 ) check = 5
	if ( tests < 3 ) tests = 3

	set_pcvar_num(hpk_ping,ping)
	set_pcvar_num(hpk_tests,tests)
	set_pcvar_num(hpk_check,check)
	set_pcvar_num(hpk_delay,delay)
	set_pcvar_num(hpk_immunity,immune)

	return PLUGIN_HANDLED    
}

stock ChatColor(const id, const szMessage[], any:...) 
{
	new iCount = 1, iPlayers[32], Player

	static szMsg[191]
	vformat(szMsg, charsmax(szMsg), szMessage, 3)

	replace_all(szMsg, charsmax(szMsg), "!g", "^4")
	replace_all(szMsg, charsmax(szMsg), "!y", "^1")
	replace_all(szMsg, charsmax(szMsg), "!t", "^3")
	
	if(id) iPlayers[0] = id; else get_players(iPlayers, iCount, "ch")
	{
		for(new i = 0; i < iCount; i++)
		{
			Player = iPlayers[i]

			message_begin(MSG_ONE_UNRELIABLE, gSayText, .player = Player )  
			write_byte(Player)
			write_string(szMsg)
			message_end()
		}
	}
}
