#include <amxmodx>
#include <fakemeta>

#define PLUGIN			"Anti-Cheat"
#define VERSION			"1.0"
#define AUTHOR			"EFFx"

#define MAX_WARN 		3
#define WORDS			64

new szWarning[33]

new g_szWordsFile[128]
new g_szWords[WORDS][32], g_iCount

new bool:g_bFakeAdded, bool:is_fake[33]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_dictionary("furien_gamesites.txt")
	
	register_clcmd ("say", "hook_say")
	register_clcmd ("say_team", "hook_say")
	
	set_task(1.0, "MakeBot")
}

public plugin_cfg()
{
	static dir[ 64 ]
	get_localinfo( "amxx_configsdir", dir, 63 )
	formatex(g_szWordsFile, 127, "%s/FurienSettings/furien_words.ini", dir)
	
	if(!file_exists(g_szWordsFile))
	{
		write_file(g_szWordsFile, "// FURIEN GAMESITES WORDS", -1)
		write_file(g_szWordsFile, "// PUT YOUR WORDS FOR BLOCK IN CHAT HERE", -1)
		write_file(g_szWordsFile, "// EXAMPLE: fuck", -1)
	}
		
	new iLen
	
	while(g_iCount < WORDS && read_file(g_szWordsFile, g_iCount ,g_szWords[g_iCount][1], 30, iLen))
	{
		if(g_szWordsFile[0] == ';' || g_szWordsFile[0] == '/' && g_szWordsFile[1] == '/')
			continue
			
		g_szWords[g_iCount][0] = iLen
		g_iCount++
	}
}

public hook_say(id)
{
	new message[192]
	read_argv(1, message, charsmax(message))
	remove_quotes(message)
	
	if(CheckWord(id, message))
		return PLUGIN_HANDLED
		
	return PLUGIN_CONTINUE
}

public client_putinserver(id)
{
	if(!is_fake[id])
	{
		if(get_playersnum() >= 17)
		{
			if(g_bFakeAdded)
			{
				RemoveBot()
			}
		}
	}	
}
public client_disconnect(id)
{
	if(!is_fake[id])
	{
		if(get_playersnum() <= 9)
		{
			if(!g_bFakeAdded)
			{
				set_task(0.1, "MakeBot")
			}
		}
	}
}

public MakeBot()
{
	new Bot = engfunc(EngFunc_CreateFakeClient, "Anti-Cheat [Monitoring]")
	
	if(Bot > 0)
	{
		is_fake[Bot] = true
		
		dllfunc(MetaFunc_CallGameEntity, "player", Bot)
		set_pev(Bot, pev_flags, FL_FAKECLIENT)

		set_pev(Bot, pev_model, "")
		set_pev(Bot, pev_viewmodel2, "")
		set_pev(Bot, pev_modelindex, 0)

		set_pev(Bot, pev_renderfx, kRenderFxNone)
		set_pev(Bot, pev_rendermode, kRenderTransAlpha)
		set_pev(Bot, pev_renderamt, 0.0)
	}
	g_bFakeAdded = true
}

RemoveBot()
{
	for(new id = 1; id <= 32; id++) 
	{
		if (is_fake[id]) 
		{
			server_cmd("kick ^"#%d^"",get_user_userid(id))
		}
	}
	g_bFakeAdded = false
}

bool:CheckWord(id, szMessage[])
{
	new bool:g_Sweared
		
	for(new i; i < g_iCount; ++i)
	{
		if(containi(szMessage, g_szWords[i][1]) != -1)
		{
			g_Sweared = true
			continue
		}
	}
		
	if(g_Sweared)
	{
		szWarning[id] += 1
		if(szWarning[id] < MAX_WARN)
		{
			client_print(id, print_chat, "[Anti-Cheat]: %L", id, "PLAYER_BAD_WORDS_WARNING")
		}
		else
		{
			check_warn(id)
		}
		return true
	}
	return false
}

public check_warn(id)
{
	if(szWarning[id] == MAX_WARN || szWarning[id] >= MAX_WARN)
	{	
		new szName[32]
		get_user_name(id, szName, 31)
		new ID = get_user_userid(id)
		
		client_print(id, print_console, "%L", id, "PLAYER_KICKED_CONSOLE_MSG") 
		client_print(id, print_console, "%L", id, "PLAYER_KICKED_CONSOLE_REASON" )
		
		server_cmd("kick #%d ^"%L^"", ID, id, "PLAYER_KICKED_CONSOLE_MSG" )
		
		client_print(0, print_chat, "[Anti-Cheat] %L", LANG_PLAYER, "PLAYER_KICKED_SHOW_ALL", szName )
	}
	return PLUGIN_HANDLED
}
