#include <amxmodx>
#include <hamsandwich>
#include <csx>

#define PLUGIN "SpawnStats"
#define VERSION "1.0"
#define AUTHOR "EFFx"

#if AMXX_VERSION_NUM < 183
#define MAX_NAME_LENGTH         			31
#endif

#define MAX_BUFFER_LENGTH       			2047

new g_szName[MAX_NAME_LENGTH+1] =			""

new bool:g_bFirstSpawn[33], gMsgSayText

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	gMsgSayText = get_user_msgid("SayText")

	register_dictionary("furien_gamesites.txt")
	
	RegisterHam(Ham_Spawn, "player", "ham_Player_Spawn_Post", 1)
}

public ham_Player_Spawn_Post(id)
{
	if(is_user_alive(id))
	{
		if(!g_bFirstSpawn[id])
		{
			g_bFirstSpawn[id] = true
			
			set_task(0.4, "showStats", id, .flags = "a", .repeat = 4)
		}
	}
}

public showStats(id)
{
	new izStats[8], izBody[8]
	new iRankPos, iRankMax = get_statsnum()	
	
	iRankPos = get_user_stats(id, izStats, izBody)
	
	ChatColor(id, "!g-------------- %L --------------", id, "CHAT_STATS_STATISTICS")
	ChatColor(id, "%L", id, "CHAT_STATS_POSITION", iRankPos, iRankMax)
	
	new iLen, sBuffer[MAX_BUFFER_LENGTH+1]
	
	if (iRankMax > 3)
		iRankMax = 3

	for (new i = 0; i < iRankMax && MAX_BUFFER_LENGTH - iLen > 0; i++)
	{
		get_stats(i, izStats, izBody, g_szName, MAX_NAME_LENGTH)
		iLen += format(sBuffer[iLen], MAX_BUFFER_LENGTH - iLen, "%2d. %-22.22s%s", i + 1, g_szName, (i + 1 > 2 ) ? ", " : "")
	}
	
	ChatColor(id, "%L", id, "CHAT_STATS_TOP", sBuffer)
	ChatColor(id, "%L", id, "CHAT_STATS_COMMANDS")
	ChatColor(id, "!g-------------- %L --------------", id, "CHAT_STATS_STATISTICS")
}

stock ChatColor(const id, const szMessage[], any:...) 
{
	new iCount = 1, iPlayers[32], Player

	static szMsg[191]
	vformat(szMsg, charsmax(szMsg), szMessage, 3)

	replace_all(szMsg, charsmax(szMsg), "!g", "^4")
	replace_all(szMsg, charsmax(szMsg), "!y", "^1")
	replace_all(szMsg, charsmax(szMsg), "!t", "^3")
	
	if(id) iPlayers[0] = id; else get_players(iPlayers, iCount, "ch")
	{
		for(new i = 0; i < iCount; i++)
		{
			Player = iPlayers[i]

			message_begin(MSG_ONE_UNRELIABLE, gMsgSayText, .player = Player )  
			write_byte(Player)
			write_string(szMsg)
			message_end()
		}
	}
}
