#include <amxmodx>

#define MIN_AFK_TIME 20
#define CHECK_FREQ 5

new g_oldangles[33][3]
new g_afktime[33]
new bool:g_spawned[33] = {true, ...}

public plugin_init() 
{
	register_plugin("AFK Bomb Drop","1.0","BlackFlagg") 

	register_cvar("mp_afktime", "20")
	register_cvar("mp_afkminplayers", "1")
	
	set_task(float(CHECK_FREQ),"checkPlayers",_,_,_,"b")
	
	register_event("ResetHUD", "playerSpawned", "be")
}

public checkPlayers() 
{
	new iPlayers[32], iNum, id
	get_players(iPlayers, iNum, "ach")
	for(new i;i < iNum;i++)
	{
		id = iPlayers[i]
		
		if (g_spawned[id]) 
		{
			new newangle[3]
			get_user_origin(id, newangle)

			if(newangle[0] == g_oldangles[id][0] && newangle[1] == g_oldangles[id][1] && newangle[2] == g_oldangles[id][2] ) 
			{
				g_afktime[id] += CHECK_FREQ
				check_afktime(id)
			} 
			else 
			{
				g_oldangles[id][0] = newangle[0]
				g_oldangles[id][1] = newangle[1]
				g_oldangles[id][2] = newangle[2]
				g_afktime[id] = 0
			}
		}
	}
	return PLUGIN_HANDLED
}

check_afktime(id) 
{
	new numplayers = get_playersnum()
	new minplayers = get_cvar_num("mp_afkminplayers")
					
	if (numplayers >= minplayers) 
	{
		new maxafktime = get_cvar_num("mp_afktime")
		if (maxafktime < MIN_AFK_TIME) 
		{
			log_amx("cvar mp_afktime %i is too low. Minimum value is %i.", maxafktime, MIN_AFK_TIME)
			maxafktime = MIN_AFK_TIME
			set_cvar_num("mp_afktime", MIN_AFK_TIME)
		}

		if (g_afktime[id] > maxafktime) 
		{
			new szName[32]
			get_user_name(id, szName, charsmax(szName))
			client_cmd(id,"drop weapon_c4") 
		}
	}
}

public client_putinserver(id) 
{
	g_afktime[id] = 0
}

public playerSpawned(id) 
{
	g_spawned[id] = false
	
	new sid[1]
	sid[0] = id
	
	set_task(0.75, "delayedSpawn",_, sid, 1)	
}

public delayedSpawn(sid[]) 
{
	get_user_origin(sid[0], g_oldangles[sid[0]])
	g_spawned[sid[0]] = true
}
