#include <amxmodx>
#include <fakemeta>
#include <fakemeta_util>
#include <engine>

#define MAX_PLAYERS 32

new const Float:CheckInterval = 1.0;

new g_msgFade , CvarDistance,HudKemp;

public plugin_init()
{
	register_plugin( "Dont Bomb Camp" , "1.1b" , "naven/bugsy" );
     
	HudKemp = CreateHudSyncObj()

	register_dictionary("furien_gamesites.txt")
    
	new szMap[ 4 ];
	get_mapname( szMap , charsmax( szMap ) );
    
	if ( szMap[ 0 ] == 'd' && szMap[ 1 ] == 'e' && szMap[ 2 ] == '_')
	{
		g_msgFade = get_user_msgid("ScreenFade");
		CvarDistance = register_cvar("gb_distance", "170.0");
		set_task( CheckInterval , "BombCheckTask" , .flags="b" );
	}
}

public BombCheckTask()
{
	new Float:fOrigin[ 3 ] , weapbox, bomb , id , playersList[32] , playersCount;
    
	bomb = fm_find_ent_by_class( -1 , "weapon_c4" );
    
	if ( bomb && !( 1 <= ( weapbox = pev( bomb , pev_owner ) ) <= MAX_PLAYERS ) && pev_valid( weapbox ) )
	{
		pev( weapbox , pev_origin , fOrigin );

		playersCount = find_sphere_class( 0 , "player" , get_pcvar_float( CvarDistance ) , playersList , sizeof( playersList ) , fOrigin );
            
		for ( new i = 0 ; i < playersCount ; i++ )
		{
			id = playersList[ i ];
            
			if(get_user_team(id) == 2 && is_user_alive(id))
			{
				message_begin(MSG_ONE, g_msgFade, {0,0,0}, id);
				write_short(1<<12);
				write_short( FixedUnsigned16( CheckInterval , 1 << 12 ) );
				write_short(0);
				write_byte(0);
				write_byte(0);
				write_byte(0);
				write_byte(255);
				message_end();
            
				set_hudmessage(255, 0, 0, -1.0, 0.20, 0, 0.1, CheckInterval, _, _, -1)
				ShowSyncHudMsg(id, HudKemp,"%L", id, "BOMB_KEMP_MSG" );
			}
		}
	}
}

FixedUnsigned16(Float:flValue, iScale)
{
	new iOutput;

	iOutput = floatround(flValue * iScale);

	if ( iOutput < 0 )
		iOutput = 0;

	if ( iOutput > 0xFFFF )
		iOutput = 0xFFFF;

	return iOutput;
}
